## API Report File for "@angular-devkit/build-angular"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="@types/node/http" />
/// <reference types="@types/node/ts4.8/http" />
/// <reference types="node" />

import { BuilderContext } from '@angular-devkit/architect';
import { BuilderOutput } from '@angular-devkit/architect';
import type { ConfigOptions } from 'karma';
import { Configuration } from 'webpack';
import { DevServerBuildOutput } from '@angular-devkit/build-webpack';
import type http from 'node:http';
import { json } from '@angular-devkit/core';
import { Observable } from 'rxjs';
import { OutputFile } from 'esbuild';
import type { Plugin as Plugin_2 } from 'esbuild';
import webpack from 'webpack';
import { WebpackLoggingCallback } from '@angular-devkit/build-webpack';

// @public
export interface ApplicationBuilderOptions {
    allowedCommonJsDependencies?: string[];
    aot?: boolean;
    appShell?: boolean;
    assets?: AssetPattern_2[];
    baseHref?: string;
    browser: string;
    budgets?: Budget_2[];
    clearScreen?: boolean;
    crossOrigin?: CrossOrigin_2;
    define?: {
        [key: string]: string;
    };
    deleteOutputPath?: boolean;
    externalDependencies?: string[];
    extractLicenses?: boolean;
    fileReplacements?: FileReplacement_2[];
    i18nDuplicateTranslation?: I18NTranslation_2;
    i18nMissingTranslation?: I18NTranslation_2;
    index: IndexUnion_2;
    inlineStyleLanguage?: InlineStyleLanguage_2;
    loader?: {
        [key: string]: any;
    };
    localize?: Localize_2;
    namedChunks?: boolean;
    optimization?: OptimizationUnion_2;
    outputHashing?: OutputHashing_2;
    outputPath: OutputPathUnion;
    poll?: number;
    polyfills?: string[];
    prerender?: PrerenderUnion;
    preserveSymlinks?: boolean;
    progress?: boolean;
    scripts?: ScriptElement_2[];
    server?: string;
    serviceWorker?: ServiceWorker_2;
    sourceMap?: SourceMapUnion_2;
    ssr?: SsrUnion;
    statsJson?: boolean;
    stylePreprocessorOptions?: StylePreprocessorOptions_2;
    styles?: StyleElement_2[];
    subresourceIntegrity?: boolean;
    tsConfig: string;
    verbose?: boolean;
    watch?: boolean;
    webWorkerTsConfig?: string;
}

// @public (undocumented)
export type AssetPattern = AssetPatternObject | string;

// @public (undocumented)
export interface AssetPatternObject {
    followSymlinks?: boolean;
    glob: string;
    ignore?: string[];
    input: string;
    output: string;
}

// @public
export interface BrowserBuilderOptions {
    allowedCommonJsDependencies?: string[];
    aot?: boolean;
    assets?: AssetPattern[];
    baseHref?: string;
    budgets?: Budget[];
    buildOptimizer?: boolean;
    commonChunk?: boolean;
    crossOrigin?: CrossOrigin;
    deleteOutputPath?: boolean;
    // @deprecated
    deployUrl?: string;
    extractLicenses?: boolean;
    fileReplacements?: FileReplacement[];
    i18nDuplicateTranslation?: I18NTranslation;
    i18nMissingTranslation?: I18NTranslation;
    index: IndexUnion;
    inlineStyleLanguage?: InlineStyleLanguage;
    localize?: Localize;
    main: string;
    namedChunks?: boolean;
    ngswConfigPath?: string;
    optimization?: OptimizationUnion;
    outputHashing?: OutputHashing;
    outputPath: string;
    poll?: number;
    polyfills?: Polyfills;
    preserveSymlinks?: boolean;
    progress?: boolean;
    resourcesOutputPath?: string;
    scripts?: ScriptElement[];
    serviceWorker?: boolean;
    sourceMap?: SourceMapUnion;
    statsJson?: boolean;
    stylePreprocessorOptions?: StylePreprocessorOptions;
    styles?: StyleElement[];
    subresourceIntegrity?: boolean;
    tsConfig: string;
    vendorChunk?: boolean;
    verbose?: boolean;
    watch?: boolean;
    webWorkerTsConfig?: string;
}

// @public
export type BrowserBuilderOutput = BuilderOutput & {
    stats: BuildEventStats;
    baseOutputPath: string;
    outputs: {
        locale?: string;
        path: string;
        baseHref?: string;
    }[];
};

// @public (undocumented)
export interface Budget {
    baseline?: string;
    error?: string;
    maximumError?: string;
    maximumWarning?: string;
    minimumError?: string;
    minimumWarning?: string;
    name?: string;
    type: Type;
    warning?: string;
}

// @public
export function buildApplication(options: ApplicationBuilderOptions, context: BuilderContext, plugins?: Plugin_2[]): AsyncIterable<ApplicationBuilderOutput>;

// @public
export function buildApplication(options: ApplicationBuilderOptions, context: BuilderContext, extensions?: ApplicationBuilderExtensions): AsyncIterable<ApplicationBuilderOutput>;

// @public
export enum CrossOrigin {
    // (undocumented)
    Anonymous = "anonymous",
    // (undocumented)
    None = "none",
    // (undocumented)
    UseCredentials = "use-credentials"
}

// @public
export interface DevServerBuilderOptions {
    allowedHosts?: string[];
    // @deprecated
    browserTarget?: string;
    buildTarget?: string;
    disableHostCheck?: boolean;
    forceEsbuild?: boolean;
    headers?: {
        [key: string]: string;
    };
    hmr?: boolean;
    host?: string;
    liveReload?: boolean;
    open?: boolean;
    poll?: number;
    port?: number;
    prebundle?: PrebundleUnion;
    proxyConfig?: string;
    publicHost?: string;
    servePath?: string;
    ssl?: boolean;
    sslCert?: string;
    sslKey?: string;
    verbose?: boolean;
    watch?: boolean;
}

// @public
export type DevServerBuilderOutput = DevServerBuildOutput & {
    baseUrl: string;
    stats: BuildEventStats;
};

// @public
export function executeBrowserBuilder(options: BrowserBuilderOptions, context: BuilderContext, transforms?: {
    webpackConfiguration?: ExecutionTransformer<webpack.Configuration>;
    logging?: WebpackLoggingCallback;
    indexHtml?: IndexHtmlTransform;
}): Observable<BrowserBuilderOutput>;

// @public
export function executeDevServerBuilder(options: DevServerBuilderOptions, context: BuilderContext, transforms?: {
    webpackConfiguration?: ExecutionTransformer<Configuration>;
    logging?: WebpackLoggingCallback;
    indexHtml?: IndexHtmlTransform;
}, extensions?: {
    buildPlugins?: Plugin_2[];
    middleware?: ((req: http.IncomingMessage, res: http.ServerResponse, next: (err?: unknown) => void) => void)[];
    builderSelector?: (info: BuilderSelectorInfo, logger: BuilderContext['logger']) => string;
}): Observable<DevServerBuilderOutput>;

// @public
export function executeExtractI18nBuilder(options: ExtractI18nBuilderOptions, context: BuilderContext, transforms?: {
    webpackConfiguration?: ExecutionTransformer<webpack.Configuration>;
}): Promise<BuilderOutput>;

// @public
export function executeKarmaBuilder(options: KarmaBuilderOptions, context: BuilderContext, transforms?: {
    webpackConfiguration?: ExecutionTransformer<Configuration>;
    karmaOptions?: (options: KarmaConfigOptions) => KarmaConfigOptions;
}): Observable<BuilderOutput>;

// @public
export function executeNgPackagrBuilder(options: NgPackagrBuilderOptions, context: BuilderContext): Observable<BuilderOutput>;

// @public
export function executeProtractorBuilder(options: ProtractorBuilderOptions, context: BuilderContext): Promise<BuilderOutput>;

// @public
export function executeServerBuilder(options: ServerBuilderOptions, context: BuilderContext, transforms?: {
    webpackConfiguration?: ExecutionTransformer<webpack.Configuration>;
}): Observable<ServerBuilderOutput>;

// @public (undocumented)
export function executeSSRDevServerBuilder(options: SSRDevServerBuilderOptions, context: BuilderContext): Observable<SSRDevServerBuilderOutput>;

// @public
export type ExecutionTransformer<T> = (input: T) => T | Promise<T>;

// @public
export interface ExtractI18nBuilderOptions {
    // @deprecated
    browserTarget?: string;
    buildTarget?: string;
    format?: Format;
    outFile?: string;
    outputPath?: string;
    progress?: boolean;
}

// @public (undocumented)
export interface FileReplacement {
    // (undocumented)
    replace?: string;
    // (undocumented)
    replaceWith?: string;
    // (undocumented)
    src?: string;
    // (undocumented)
    with?: string;
}

// @public
export interface KarmaBuilderOptions {
    assets?: AssetPattern_3[];
    browsers?: Browsers;
    codeCoverage?: boolean;
    codeCoverageExclude?: string[];
    exclude?: string[];
    fileReplacements?: FileReplacement_3[];
    include?: string[];
    inlineStyleLanguage?: InlineStyleLanguage_3;
    karmaConfig?: string;
    main?: string;
    poll?: number;
    polyfills?: Polyfills_2;
    preserveSymlinks?: boolean;
    progress?: boolean;
    reporters?: string[];
    scripts?: ScriptElement_3[];
    sourceMap?: SourceMapUnion_3;
    stylePreprocessorOptions?: StylePreprocessorOptions_3;
    styles?: StyleElement_3[];
    tsConfig: string;
    watch?: boolean;
    webWorkerTsConfig?: string;
}

// @public (undocumented)
export type KarmaConfigOptions = ConfigOptions & {
    buildWebpack?: unknown;
    configFile?: string;
};

// @public
export interface NgPackagrBuilderOptions {
    project: string;
    tsConfig?: string;
    watch?: boolean;
}

// @public (undocumented)
export interface OptimizationObject {
    fonts?: FontsUnion;
    scripts?: boolean;
    styles?: StylesUnion;
}

// @public
export type OptimizationUnion = boolean | OptimizationObject;

// @public
export enum OutputHashing {
    // (undocumented)
    All = "all",
    // (undocumented)
    Bundles = "bundles",
    // (undocumented)
    Media = "media",
    // (undocumented)
    None = "none"
}

// @public
export interface ProtractorBuilderOptions {
    baseUrl?: string;
    devServerTarget?: string;
    grep?: string;
    host?: string;
    invertGrep?: boolean;
    port?: number;
    protractorConfig: string;
    specs?: string[];
    suite?: string;
    webdriverUpdate?: boolean;
}

// @public (undocumented)
export interface ServerBuilderOptions {
    assets?: AssetPattern_4[];
    buildOptimizer?: boolean;
    deleteOutputPath?: boolean;
    // @deprecated
    deployUrl?: string;
    externalDependencies?: string[];
    extractLicenses?: boolean;
    fileReplacements?: FileReplacement_4[];
    i18nDuplicateTranslation?: I18NTranslation_3;
    i18nMissingTranslation?: I18NTranslation_3;
    inlineStyleLanguage?: InlineStyleLanguage_4;
    localize?: Localize_3;
    main: string;
    namedChunks?: boolean;
    optimization?: OptimizationUnion_3;
    outputHashing?: OutputHashing_3;
    outputPath: string;
    poll?: number;
    preserveSymlinks?: boolean;
    progress?: boolean;
    resourcesOutputPath?: string;
    sourceMap?: SourceMapUnion_4;
    statsJson?: boolean;
    stylePreprocessorOptions?: StylePreprocessorOptions_4;
    tsConfig: string;
    vendorChunk?: boolean;
    verbose?: boolean;
    watch?: boolean;
}

// @public
export type ServerBuilderOutput = BuilderOutput & {
    baseOutputPath: string;
    outputPath: string;
    outputs: {
        locale?: string;
        path: string;
    }[];
};

// @public (undocumented)
export interface SourceMapObject {
    hidden?: boolean;
    scripts?: boolean;
    styles?: boolean;
    vendor?: boolean;
}

// @public
export type SourceMapUnion = boolean | SourceMapObject;

// @public (undocumented)
export type SSRDevServerBuilderOptions = Schema & json.JsonObject;

// @public (undocumented)
export type SSRDevServerBuilderOutput = BuilderOutput & {
    baseUrl?: string;
    port?: string;
};

// @public
export interface StylePreprocessorOptions {
    includePaths?: string[];
}

// @public
export enum Type {
    // (undocumented)
    All = "all",
    // (undocumented)
    AllScript = "allScript",
    // (undocumented)
    Any = "any",
    // (undocumented)
    AnyComponentStyle = "anyComponentStyle",
    // (undocumented)
    AnyScript = "anyScript",
    // (undocumented)
    Bundle = "bundle",
    // (undocumented)
    Initial = "initial"
}

// (No @packageDocumentation comment for this package)

```
